--##########################################################################
-- XAPP 219 : Transposed Form FIR filters

-- Engineer:  Vikram Pasham
--            Xilinx Applications
-- Date :     9/4/2000

-- The following code implements a clock DLL to generate a divide by four 
-- operation. 
-- One DLL is used to generate clock divide operation

--###########################################################################
  


library ieee;
use ieee.std_logic_1164.all;



-- Functional Simulation Libraries
-- PRAGMA translate_off
library unisim;
use unisim.vcomponents.all;
-- PRAGMA translate_on



-- The folowing library declarartions are specific to Synplify synthesis
-- tool. 

--library virtex;
--use virtex.components.all;

entity DLL_CLOCK is
    port (CLKIN : in  std_logic;
          RESET : in  std_logic;
          CLK0  : out std_logic;
          CLKDV: out std_logic;
          LOCKED: out std_logic);
end DLL_CLOCK;

architecture structural of DLL_CLOCK is

signal CLKIN_w, RESET_w, CLK0_dll, CLKDV_dll, CLKDV_g, CLK0_g, LOCKED_dll,CLK0_w : std_logic;
component IBUFG 
port(
      O   :	out   STD_LOGIC;
      I   :	in    STD_LOGIC);
end component;


component BUFG 
   port(
      O  :	out   STD_LOGIC;
      I  :	in    STD_LOGIC);
end component;


component CLKDLL 
    port ( CLKIN   : in  std_logic := '0';
           CLKFB   : in  std_logic := '0';
           RST     : in  std_logic := '0';
           CLK0    : out std_logic := '0';
           CLK90   : out std_logic := '0';
           CLK180  : out std_logic := '0';
           CLK270  : out std_logic := '0';
           CLK2X   : out std_logic := '0';
           CLKDV   : out std_logic := '0';
           LOCKED  : out std_logic := '0');
end component;



begin 

clkpad : IBUFG  port map (I=>CLKIN, O=>CLKIN_w);


dll    : CLKDLL 
             port map (CLKIN=>CLKIN_w, CLKFB=>CLK0_g, RST=>RESET,
                          CLK0=>CLK0_w, CLK90=>open, CLK180=>open, CLK270=>open,
                          CLK2X=>open,    CLKDV=>CLKDV_dll, LOCKED=>LOCKED);

clkg   : BUFG   port map (I=>CLK0_w,   O=>CLK0_g);
clkdvg : BUFG   port map (I=>CLKDV_dll,   O=>CLKDV_g);  


CLK0 <= CLK0_g;
CLKDV <= CLKDV_g;

end structural;




















