--########################################################################## 
-- XAPP 219 : Transposed Form FIR filters

-- Engineer:  Vikram Pasham
-- 	      Xilinx Applications
-- Date :     9/4/2000

-- The following code lists all the ROM contents for all KCM  multipliers. 
-- Each ROM corresponds to a tap in the filter.

-- This example lists 8-tap Transposed Form FIR Filter with coefficients 
-- k0 = 2, k1 = 10, k2 = 20, k3 = 30, k4 = -30, k5 = -20, k6 = -10, k7 = -2 



--###########################################################################



library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use work.all;

package pack_rom16x18 is


	type mem_array is array (0 to 15) of integer range -2**9 to 2**9 -1;


	constant rom_table0: mem_array := (0, 2, 4, 6, 8, 10, 12, 14,
                                  16, 18, 20, 22, 24, 26, 28, 30); 	
                                   
	constant rom_table1: mem_array := (0, 10, 20, 30, 40, 50, 60, 70, 80, 
														90, 100, 110,120, 130, 140, 150); 	

	constant rom_table2: mem_array  := (0, 20, 40, 60, 80, 100, 120, 140, 160,
														  180, 200,  220, 240, 260, 280, 300);

	constant rom_table3: mem_array := (0, 30, 60, 90, 120, 150, 180, 210, 240, 
             														270, 300, 330, 360, 390, 420, 450);

	constant rom_table4: mem_array := (0, -30, -60, -90, -120, -150, -180, -210, -240, 
           														 -270, -300, -330, -360, -390, -420, -450);

	constant rom_table5: mem_array  := (0, -20, -40, -60, -80, -100, -120, -140, -160,
                                     -180, -200,  -220, -240, -260, -280, -300);
    				  
	constant rom_table6: mem_array := (0, -10, -20, -30, -40, -50, -60, -70, -80, -90, 
    				                          -100, -110, -120, -130, -140, -150);                                   	

	constant rom_table7: mem_array := (0, -2, -4, -6, -8, -10, -12, -14,
                                  -16, -18, -20, -22, -24, -26, -28, -30); 

end pack_rom16x18;










